default:
  tags: ["mintlab"]

stages:
  - Prepare
  - Build
  - Release

.rules_release_and_mrs: &rules_release_and_mrs
  rules:
    - if: $CI_PROJECT_ROOT_NAMESPACE != "xxllnc" && $CI_PROJECT_ROOT_NAMESPACE != "zaaksysteem"
      when: never
    - if: $CI_MERGE_REQUEST_ID
    - if: $CI_COMMIT_BRANCH =~ /^(master|production|preprod|development|trial)$/
    - if: $CI_COMMIT_TAG

.rules_master_only: &rules_master_only
  rules:
    - if: $CI_PROJECT_ROOT_NAMESPACE != "xxllnc" && $CI_PROJECT_ROOT_NAMESPACE != "zaaksysteem"
      when: never
    - if: $CI_COMMIT_BRANCH == "master"

# ------ Generic jobs ------

Prepare App bundles:
  <<: *rules_release_and_mrs
  stage: Prepare
  image: node:lts
  cache:
    paths:
      - ./node_modules/.cache
      - ./apps/main/node_modules/.cache
      - ./apps/my-pip/node_modules/.cache
      - ./apps/admin/node_modules/.cache
      - ./apps/external-components/node_modules/.cache
  before_script:
    - (if [ -z "$(ls -A /usr/local/share/.cache/yarn/v6)" ]; then echo "Empty cache folder /usr/local/share/.cache/yarn/v6, this will slow down the pipeline, ensure it is mounted by host machine"; fi)
    - yarn
    - yarn lerna:bootstrap
  script:
    - if [ $CI_PIPELINE_SOURCE == "merge_request_event" ]; then yarn run-all-ci; else yarn run-all-ci-allow; fi
  artifacts:
    paths:
      - build/apps/
    reports:
      cyclonedx:
        - cyclonedx.json
    expire_in: 1 day

# ------ Docker image jobs ------
Build Docker images:
  <<: *rules_release_and_mrs
  stage: Build
  image: ${BUILDER_CONTAINER}:master
  dependencies:
    - 'Prepare App bundles'
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - /init.sh
    - docker buildx create --name ${BUILDKIT_NAME:-zs-builder} --use || docker buildx use ${BUILDKIT_NAME:-zs-builder}
    - docker buildx build
      --platform ${BUILDKIT_ARCHS:-linux/amd64,linux/arm64}
      --output type=registry
      --build-arg BUILD_TIMESTAMP="$(date)"
      --tag ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG}
      --tag ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG}-ci-${CI_PIPELINE_IID}
      "."

#
# Release targets
#

Copy container image to AWS ECR:
  stage: Release
  rules:
    - if: $ECR_REPOSITORY_URL == null
      when: never
    - if: $CI_PROJECT_ROOT_NAMESPACE != "xxllnc" && $CI_PROJECT_ROOT_NAMESPACE != "zaaksysteem"
      when: never
    - if: $CI_MERGE_REQUEST_ID
      when: never
    - if: $CI_COMMIT_TAG =~ /^release\//
  image: ${BUILDER_CONTAINER}:master
  before_script: []
  script:
    - $(aws ecr get-login --no-include-email --region "$AWS_ECR_REGION")
    - skopeo copy --all "docker://${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG}-ci-${CI_PIPELINE_IID}" "docker://${ECR_REPOSITORY_URL}:${CI_COMMIT_REF_SLUG}"

#
# Publish documentation
# https://zaaksysteem.gitlab.io/zaaksysteem-frontend-mono
#
# Storybook to Gitlab Pages:
#   <<: *rules_master_only
#   stage: Build
#   image: node:lts
#   before_script:
#     - yarn
#     - yarn lerna:bootstrap
#     - cd storybook && yarn
#   script:
#     - yarn build-storybook
#   artifacts:
#     paths:
#       - public
# # vim: et ts=2 sw=2
